//+------------------------------------------------------------------+
//|                                                         test.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
#property indicator_separate_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#include <MovingAverages.mqh>
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Green
#property indicator_width2 2
#property indicator_color3 Blue
#property indicator_width3 2

input int n1=500; 
input int n2=250;
input int n3=90;
input int p1=21; 
input int p2=3; 
input int p3=30; 

double var1[];double var2[];double var3[];double var4[];double var5[];
double var6[];double var7[];double var8[];double var9[];
double varA[];double varB[];double varC[];double varD[];double varE[];
double var11[];double var12[];double var13[];double var21[];double var22[];double var23[];
double var31[];double var32[];double var33[];double var41[];
double var51[];double var52[];double var53[];double var54[];
double var61[];

int OnInit()
  {
//--- indicator buffers mapping
   IndicatorBuffers(29);
   SetIndexStyle(0,DRAW_LINE,2);
   
   SetIndexBuffer(0,var61);
   SetIndexBuffer(1,varD);
   SetIndexBuffer(2,varE);
   SetIndexBuffer(3,var1);
   SetIndexBuffer(4,var2);
   SetIndexBuffer(5,var3);
   SetIndexBuffer(6,var4);
   SetIndexBuffer(7,var5);
   SetIndexBuffer(8,var6);
   SetIndexBuffer(9,var7);
   SetIndexBuffer(10,var8);
   SetIndexBuffer(11,var9);
   SetIndexBuffer(12,varA);
   SetIndexBuffer(13,varB);
   SetIndexBuffer(14,varC);
   SetIndexBuffer(15,var11);
   SetIndexBuffer(16,var12);
   SetIndexBuffer(17,var13);
   SetIndexBuffer(18,var21);
   SetIndexBuffer(19,var22);
   SetIndexBuffer(20,var23);
   SetIndexBuffer(21,var31);
   SetIndexBuffer(22,var32);
   SetIndexBuffer(23,var33);
   SetIndexBuffer(24,var41);
   SetIndexBuffer(25,var51);
   SetIndexBuffer(26,var52);
   SetIndexBuffer(27,var53);
   SetIndexBuffer(28,var54);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int    i,limit;
   //Print(0);
//---
   if(rates_total<1000) return(0);
   //limit=prev_calculated-1;
   limit=rates_total-prev_calculated;
   if(prev_calculated>0)          limit++;
   for(i=0; i<limit; i++)
     {
      var11[i]=High[iHighest(NULL,0,MODE_HIGH,n1,i)];//Print(var11[0]);
      var12[i]=High[iHighest(NULL,0,MODE_HIGH,n2,i)];
      var13[i]=High[iHighest(NULL,0,MODE_HIGH,n3,i)];
      var21[i]=Low[iLowest(NULL,0,MODE_LOW,n1,i)];
      var22[i]=Low[iLowest(NULL,0,MODE_LOW,n2,i)];
      var23[i]=Low[iLowest(NULL,0,MODE_LOW,n3,i)];
     }
   
   for(i=0; i<limit; i++)  var1[i]= iMAOnArray(var11,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var2[i]= iMAOnArray(var12,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var3[i]= iMAOnArray(var13,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var4[i]= iMAOnArray(var21,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var5[i]= iMAOnArray(var22,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var6[i]= iMAOnArray(var23,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   
   for(i=0; i<limit; i++)
   {
    var31[i]=(var1[i]*0.96+var2[i]*0.96+var3[i]*0.96+var4[i]*0.558+var5[i]*0.558+var6[i]*0.558)/6;
    var32[i]=(var1[i]*1.25+var2[i]*1.23+var3[i]*1.2 +var4[i]*0.55 +var5[i]*0.65 +var6[i]*0.55)/6;
    var33[i]=(var1[i]*1.3 +var2[i]*1.3 +var3[i]*1.3 +var4[i]*0.68 +var5[i]*0.68 +var6[i]*0.68)/6;
   }
   for(i=0; i<limit; i++)  var7[i]= iMAOnArray(var31,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var8[i]= iMAOnArray(var32,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var9[i]= iMAOnArray(var33,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   
   for(i=0; i<limit; i++)
   {
    var41[i]=(var9[i]*3+var8[i]*2+var7[i])/6*1.738;
   }
   for(i=0; i<limit; i++)  varA[i] = iMAOnArray(var41,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit-1; i++)  varB[i] =High[i+1];//Low[i+1];
   for(i=0; i<limit; i++)  var51[i]=MathAbs(High[i]-varB[i]);//MathAbs(Low[i]-varB[i]);
   for(i=0; i<limit; i++)  var52[i]=MathMax((High[i]-varB[i]),0);//MathMax((Low[i]-varB[i]),0);//
   for(i=0; i<limit; i++)  var53[i]= iMAOnArray(var51,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   for(i=0; i<limit; i++)  var54[i]= iMAOnArray(var52,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   
   for(i=0; i<limit; i++)  
   {
    if(var54[i]!=0) varC[i]=var53[i]/var54[i];//*100; 
    else varC[i]=0;//if(var54[i+1]!=0)     varC[i]=var53[i]/var54[i+1]*100; 
   }
   for(i=0; i<limit; i++)  
   {
    if(High[i]*1.35>=varA[i]) var61[i]=varC[i]*10;else var61[i]=varC[i]/10;
   }//Print("var61=",var61[20]);
   for(i=0; i<limit; i++)  varD[i]= iMAOnArray(var61,/*Bars*/rates_total,p1,0,MODE_EMA,i);
   //Print("varD=",varD[0]);
   for(i=0; i<limit-p3; i++)  
   {
    double hm=-10000;
    for(int m=i;m<i+p3;m++)
    {
     if(varD[m]>hm) hm=varD[m];
    }
    varE[i]=hm;
   }
   
   
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
